searchNodes=[{"ref":"Pop3mail.html","title":"Pop3mail","type":"module","doc":"Download email from the inbox and store them (including attachments) in a subdirectory per email. Reads incoming mail via the POP3 protocol, using an Erlang Epop client with SSL support. Decodes multipart content, quoted-printables, base64 and encoded-words. The module also contains functions to perform only the decoding, giving you the choice to do retrieval and storage with your own functions."},{"ref":"Pop3mail.html#cli/1","title":"Pop3mail.cli/1","type":"function","doc":"Commandline interface for downloading email and storing them on disk. Examples Download maximum 2 emails from the email account and also save the raw undecoded message. $ pop3mail_downloader --max=2 --raw --username=hendrik.lorentz@gmail.com --password=secret --output=mailbox or iex(1)&gt; Pop3mail.cli([&quot;--max=2&quot;, &quot;--raw&quot;, &quot;--username=hendrik.lorentz@gmail.com&quot;, &quot;--password=secret&quot;, &quot;--output=mailbox&quot;]) info: 297 emails, 57.643.477 bytes total. info: Process mail 1: Mon, 13 Oct 2015 18:34:07 +0200 info: message1.txt info: message2.html info: Solution Skolem problem.docx info: Process mail 2: Mon, 13 Oct 2015 19:38:14 +0200 info: message1.iso-8859-1.txt info: message2.iso-8859-1.html {:ok, 297} Print the usage text. It has a long explanation of all the parameters. $ pop3mail_downloader --help or iex(1)&gt; Pop3mail.cli([&quot;--help&quot;]) usage: ..."},{"ref":"Pop3mail.html#decode_body/4","title":"Pop3mail.decode_body/4","type":"function","doc":"Decode multipart, base64 and quoted-printable text. Returned is a list of Pop3mail.Part structs. Example Decode message with nested multipart content. iex(1)&gt; message = &quot;&quot;&quot; ...(1)&gt; Il s&#39;agit d&#39;un message à parties multiples au format MIME. ...(1)&gt; ...(1)&gt; ------=_NextPart_000_0004_01D0C782.71A41900 ...(1)&gt; Content-Type: multipart/alternative; ...(1)&gt; \\tboundary=&quot;----=_NextPart_001_0005_01D0C782.71A8D3F0&quot; ...(1)&gt; ...(1)&gt; ...(1)&gt; ------=_NextPart_001_0005_01D0C782.71A8D3F0 ...(1)&gt; Content-Type: text/plain; ...(1)&gt; \\tcharset=&quot;iso-8859-1&quot; ...(1)&gt; Content-Transfer-Encoding: quoted-printable ...(1)&gt; ...(1)&gt; No problem, the reception will be open until 19.30 tomorrow. ...(1)&gt; ...(1)&gt; T=E9l: 555 ...(1)&gt; ...(1)&gt; =20 ...(1)&gt; ...(1)&gt; ...(1)&gt; ------=_NextPart_001_0005_01D0C782.71A8D3F0 ...(1)&gt; Content-Type: text/html; ...(1)&gt; \\tcharset=&quot;iso-8859-1&quot; ...(1)&gt; Content-Transfer-Encoding: quoted-printable ...(1)&gt; ...(1)&gt; &lt;META HTTP-EQUIV=3D&quot;Content-Type&quot; CONTENT=3D&quot;text/html; = ...(1)&gt; charset=3Diso-8859-1&quot;&gt; ...(1)&gt; &lt;html&gt;&lt;head&gt;&lt;title&gt;hoi&lt;/title&gt;&lt;/head&gt; ...(1)&gt; &lt;body lang=3DFR link=3Dblue vlink=3Dpurple&gt; ...(1)&gt; &lt;div class=3DSection1&gt; ...(1)&gt; ...(1)&gt; &lt;p&gt; ...(1)&gt; No problem, the reception will be open until 19.30 = ...(1)&gt; tomorrow.&lt;/p&gt; ...(1)&gt; ...(1)&gt; &lt;/div&gt; ...(1)&gt; &lt;/body&gt; ...(1)&gt; &lt;/html&gt; ...(1)&gt; ...(1)&gt; ------=_NextPart_001_0005_01D0C782.71A8D3F0-- ...(1)&gt; ...(1)&gt; ------=_NextPart_000_0004_01D0C782.71A41900 ...(1)&gt; Content-Type: image/gif; ...(1)&gt; \\tname=&quot;image001.gif&quot; ...(1)&gt; Content-Transfer-Encoding: base64 ...(1)&gt; Content-ID: &lt;image001.gif@01D0C782.711C2450&gt; ...(1)&gt; ...(1)&gt; R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7 ...(1)&gt; ...(1)&gt; ------=_NextPart_000_0004_01D0C782.71A41900-- ...(1)&gt; ...(1)&gt; &quot;&quot;&quot; ...(2)&gt; message |&gt; String.replace(&quot;\\n&quot;, &quot;\\r\\n&quot;) |&gt; Pop3mail.decode_body(&quot;multipart/related; boundary=\\&quot;----=_NextPart_000_0004_01D0C782.71A41900\\&quot;&quot;, &quot;bit7&quot;, &quot;&quot;) [%Pop3mail.Part{boundary: &quot;----=_NextPart_001_0005_01D0C782.71A8D3F0&quot;, charset: &quot;iso-8859-1&quot;, content: &lt;&lt;78, 111, 32, 112, 114, 111, 98, 108, 101, 109, 44, 32, 116, 104, 101, 32, 114, 101, 99, 101, 112, 116, 105, 111, 110, 32, 119, 105, 108, 108, 32, 98, 101, 32, 111, 112, 101, 110, 32, 117, 110, 116, 105, 108, 32, 49, ...&gt;&gt;, content_id: &quot;&quot;, filename: &quot;&quot;, filename_charset: &quot;us-ascii&quot;, index: 1, inline: nil, media_type: &quot;text/plain&quot;, path: &quot;related/alternative&quot;}, %Pop3mail.Part{boundary: &quot;----=_NextPart_001_0005_01D0C782.71A8D3F0&quot;, charset: &quot;iso-8859-1&quot;, content: &quot;&lt;META HTTP-EQUIV=\\&quot;Content-Type\\&quot; CONTENT=\\&quot;text/html; charset=iso-8859-1\\&quot;&gt;\\r\\n&lt;html&gt;&lt;head&gt;&lt;title&gt;hoi&lt;/title&gt;&lt;/head&gt;\\r\\n&lt;body lang=FR link=blue vlink=purple&gt;\\r\\n&lt;div class=Section1&gt;\\r\\n\\r\\n&lt;p&gt;\\r\\nNo problem, the reception will be open until 19.30 tomorrow.&lt;/p&gt;\\r\\n\\r\\n&lt;/div&gt;\\r\\n&lt;/body&gt;\\r\\n&lt;/html&gt;\\r\\n&quot;, content_id: &quot;&quot;, filename: &quot;&quot;, filename_charset: &quot;us-ascii&quot;, index: 2, inline: nil, media_type: &quot;text/html&quot;, path: &quot;related/alternative&quot;}, %Pop3mail.Part{boundary: &quot;----=_NextPart_000_0004_01D0C782.71A41900&quot;, charset: &quot;us-ascii&quot;, content: &lt;&lt;71, 73, 70, 56, 57, 97, 1, 0, 1, 0, 128, 0, 0, 0, 0, 0, 255, 255, 255, 33, 249, 4, 1, 0, 0, 0, 0, 44, 0, 0, 0, 0, 1, 0, 1, 0, 0, 2, 1, 68, 0, 59&gt;&gt;, content_id: &quot;&lt;image001.gif@01D0C782.711C2450&gt;&quot;, filename: &quot;image001.gif&quot;, filename_charset: &quot;us-ascii&quot;, index: 2, inline: nil, media_type: &quot;image/gif&quot;, path: &quot;related&quot;}]"},{"ref":"Pop3mail.html#decode_body_content/2","title":"Pop3mail.decode_body_content/2","type":"function","doc":"Decode multipart, base64 and quoted-printable text. Returned is a list of Pop3mail.Part structs. Example Retrieve email via epop_client and decode body and close the connection. iex(1)&gt; # notice that you must use single quotes here iex(2)&gt; {:ok, client} = :epop_client.connect(&#39;user@gmail.com&#39;, &#39;password&#39;, [{:addr, &#39;pop.gmail.com&#39;},{:port,995},{:user, &#39;user@gmail.com&#39;},:ssl]) iex(3)&gt; :epop_client.stat(client) iex(4)&gt; {:ok, mail_content} = :epop_client.bin_retrieve(client, 1) iex(5)&gt; {:message, header_list, body_content } = :epop_message.bin_parse(mail_content) iex(6)&gt; Pop3mail.decode_body_content(header_list, body_content) [%Pop3mail.Part{boundary: &quot;--_com.android.email_1191110031918720&quot;, charset: &quot;utf-8&quot;, content: &quot;\\nPlease give me write access for the forum and possibly the wiki.\\n\\nTIA\\n&quot;, content_id: &quot;&quot;, filename: &quot;&quot;, filename_charset: &quot;us-ascii&quot;, index: 1, inline: nil, media_type: &quot;text/plain&quot;, path: &quot;alternative&quot;}, %Pop3mail.Part{boundary: &quot;--_com.android.email_1191110031918720&quot;, charset: &quot;utf-8&quot;, content: &quot;&lt;html&gt;&lt;head&gt;&lt;meta http-equiv=\\&quot;Content-Type\\&quot; content=\\&quot;text/html; charset=UTF-8\\&quot;&gt;&lt;/head&gt;&lt;body &gt;&lt;div&gt;&lt;br&gt;&lt;/div&gt;&lt;div&gt;Please give me write access for the forum and possibly the wiki.&lt;/div&gt;&lt;div&gt;&lt;br&gt;&lt;/div&gt;&lt;div&gt;TIA&lt;/div&gt;&lt;div&gt;&lt;br&gt;&lt;/div&gt;&lt;/body&gt;&lt;/html&gt;&quot;, content_id: &quot;&quot;, filename: &quot;&quot;, filename_charset: &quot;us-ascii&quot;, index: 2, inline: nil, media_type: &quot;text/html&quot;, path: &quot;alternative&quot;}] iex(7)&gt; :epop_client.quit(client)"},{"ref":"Pop3mail.html#decode_raw_file/2","title":"Pop3mail.decode_raw_file/2","type":"function","doc":"Decode raw message file (mostly an .eml file) and store result on disk. Returns a list with file storage results. Example Decode simple.eml and write result in the testoutput directory. iex(1)&gt; Pop3mail.decode_raw_file(&quot;test/pop3mail/fixtures/simple.eml&quot;, &quot;testoutput&quot;) info: Process mail 1: Thu, 4 Sep 2014 19:23:15 +0200 info: message1.iso-8859-1.txt [ok: &quot;testoutput/20140904_192315_Re_appointment/header.Marie.txt&quot;, ok: &quot;testoutput/20140904_192315_Re_appointment/message1.iso-8859-1.txt&quot;]"},{"ref":"Pop3mail.html#decode_words/1","title":"Pop3mail.decode_words/1","type":"function","doc":"Decode a text with encoded words as defined in RFC 2047. Returns a list with tuples of charset name and binary content. Encoded words can occur in email headers (Subject, From, To) and for filenames in multipart content. Examples Russian subject iex&gt; Pop3mail.decode_words(&quot;=?koi8-r?Q?Fwd:_=E4=CF=CD=C1=DB=CE=C5=C5_=DA=C1=C4=C1=CE=C9=C5_?=&quot;) [{&quot;koi8-r&quot;, &lt;&lt;70, 119, 100, 58, 32, 228, 207, 205, 193, 219, 206, 197, 197, 32, 218, 193, 196, 193, 206, 201, 197, 32&gt;&gt;}] French (Réception) and ascii text email address iex(1)&gt; Pop3mail.decode_words(&quot;=?iso-8859-1?Q?R=E9ception_Fayence?= &lt;reception.fayence@acme.com&gt;&quot;) [{&quot;iso-8859-1&quot;, &lt;&lt;82, 233, 99, 101, 112, 116, 105, 111, 110, 32, 70, 97, 121, 101, 110, 99, 101&gt;&gt;}, {&quot;us-ascii&quot;, &quot; &lt;reception.fayence@acme.com&gt;&quot;}] Chinese iex(1)&gt; Pop3mail.decode_words(&quot;chinese&quot;) [{&quot;us-ascii&quot;, &quot;chinese&quot;}]"},{"ref":"Pop3mail.html#download/1","title":"Pop3mail.download/1","type":"function","doc":"Download emails from the inbox and store them (including attachments) in a subdirectory per email. Parameters must be supplied in a string-keyed map: delete - delete email after downloading. Default: false. Notice that Gmail ignores the delete and instead uses the Gmail account settings. delivered - true/false. Skip emails with/without Delivered-To header. If you moved an email from your sent box to your inbox it will not have the Delivered-To header. Default: don&#39;t skip max - maximum number of emails to download. Default: unlimited output - output directory. Default: inbox password - email account password. port - pop3 server port. Default: 995 raw - also save the unprocessed mail in a file called &#39;raw.eml&#39;. Usefull feature for error diagnostics. server - pop3 server address. Default: pop.gmail.com ssl - true/false. Turn on/off Secure Socket Layer. Default: true username - email account name. Gmail users can precede the name with &#39;recent:&#39; to get the last 30 days mail, even if it has already been downloaded elsewhere. Example Download maximum 2 emails from the email account and also save the raw undecoded message. iex(1)&gt; Pop3mail.download(%{&quot;max&quot; =&gt; 2, &quot;raw&quot; =&gt; true, &quot;username&quot; =&gt; &quot;hendrik.lorentz@gmail.com&quot;, &quot;password&quot; =&gt; &quot;secret&quot;, &quot;output&quot; =&gt; &quot;mailbox&quot;})"},{"ref":"Pop3mail.html#header_lookup/2","title":"Pop3mail.header_lookup/2","type":"function","doc":"Lookup header in header list retrieved via epop. Example Retrieve email via epop_client and lookup headers &#39;Data&#39;, &#39;Subject&#39; and &#39;From&#39; and close the connection. iex(1)&gt; # notice that you must use single quotes here iex(2)&gt; {:ok, client} = :epop_client.connect(&#39;user@gmail.com&#39;, &#39;password&#39;, [{:addr, &#39;pop.gmail.com&#39;},{:port,995},{:user, &#39;user@gmail.com&#39;},:ssl]) iex(3)&gt; :epop_client.stat(client) iex(4)&gt; {:ok, mail_content} = :epop_client.bin_retrieve(client, 1) iex(5)&gt; {:message, header_list, body_content } = :epop_message.bin_parse(mail_content) iex(6)&gt; Pop3mail.header_lookup(header_list, &quot;Subject&quot;) &quot;Solution Skolem problem&quot; iex(7)&gt; Pop3mail.header_lookup(header_list, &quot;From&quot;) &quot;Hendrik Lorentz &lt;hendrik.lorentz@gmail.com&gt;&quot; iex(8)&gt; Pop3mail.header_lookup(header_list, &quot;Date&quot;) &quot;Thu, 11 Jun 2015 18:05:26 +0000 (UTC)&quot; iex(9)&gt; :epop_client.quit(client)"},{"ref":"Pop3mail.Base64Decoder.html","title":"Pop3mail.Base64Decoder","type":"module","doc":"Replaceable base64 decoder. Replace with your own implementation via the application config :pop3mail, base64_decoder: &lt;replacement&gt; After changing the config/config.exs run: mix deps.compile --force pop3mail"},{"ref":"Pop3mail.Base64Decoder.html#decode!/1","title":"Pop3mail.Base64Decoder.decode!/1","type":"function","doc":"Decode base64 encoded text, ignoring carriage returns and linefeeds. Returns binary."},{"ref":"Pop3mail.Base64Decoder.Standard.html","title":"Pop3mail.Base64Decoder.Standard","type":"module","doc":"Standard Elixir base64 decoder"},{"ref":"Pop3mail.Base64Decoder.Standard.html#decode!/1","title":"Pop3mail.Base64Decoder.Standard.decode!/1","type":"function","doc":"Decode base64 encoded text, ignoring carriage returns and linefeeds. Returns binary."},{"ref":"Pop3mail.Body.html","title":"Pop3mail.Body","type":"module","doc":"Decode and store mail body"},{"ref":"Pop3mail.Body.html#decode_body/4","title":"Pop3mail.Body.decode_body/4","type":"function","doc":"Decode multipart content, base64, quoted-printables"},{"ref":"Pop3mail.Body.html#store_multiparts/2","title":"Pop3mail.Body.store_multiparts/2","type":"function","doc":"Store all found body parts on filesystem"},{"ref":"Pop3mail.Body.html#store_part/2","title":"Pop3mail.Body.store_part/2","type":"function","doc":"Store one part on filesystem"},{"ref":"Pop3mail.CLI.html","title":"Pop3mail.CLI","type":"module","doc":"Commandline interface for downloading emails and storing them on disk."},{"ref":"Pop3mail.CLI.html#main/1","title":"Pop3mail.CLI.main/1","type":"function","doc":"Call main with parameters. E.g. main([&quot;--username=a.b@gmail.com&quot;, &quot;--password=secret&quot;]). Call with --help to get a list of all parameters."},{"ref":"Pop3mail.CLI.html#show_help/0","title":"Pop3mail.CLI.show_help/0","type":"function","doc":"print usage line and a description for all parameters."},{"ref":"Pop3mail.DateConverter.html","title":"Pop3mail.DateConverter","type":"module","doc":"Date conversions and date utilities"},{"ref":"Pop3mail.DateConverter.html#convert_date/1","title":"Pop3mail.DateConverter.convert_date/1","type":"function","doc":"Convert date from email header to a standard date format: YYYYMMDD_HHMMSS datestr - must be conform RFC 2822 date format"},{"ref":"Pop3mail.DateConverter.html#zero_pad/2","title":"Pop3mail.DateConverter.zero_pad/2","type":"function","doc":"add zero&#39;s at left side of the number"},{"ref":"Pop3mail.EpopDownloader.html","title":"Pop3mail.EpopDownloader","type":"module","doc":"Retrieve and parse POP3 mail via the Epop client."},{"ref":"Pop3mail.EpopDownloader.html#download/1","title":"Pop3mail.EpopDownloader.download/1","type":"function","doc":"Read all emails and save them to disk. options - EpopDownloader.Options"},{"ref":"Pop3mail.EpopDownloader.html#parse_process_and_store/5","title":"Pop3mail.EpopDownloader.parse_process_and_store/5","type":"function","doc":"Parse headers, decode body and store everything. mail_content - string with the complete raw email message. mail_loop_count - number of the email in the current session. delivered - true/false/nil. Presence, absence or don&#39;t care of the &#39;Delivered-To&#39; email header. save_raw - true/false. Save or don&#39;t save the raw email message. output_dir - directory where all emails are stored."},{"ref":"Pop3mail.EpopDownloader.html#retrieve_and_store/3","title":"Pop3mail.EpopDownloader.retrieve_and_store/3","type":"function","doc":"Retrieve, parse and store an email. epop_client - client returned by :epop_client.connect function. mail_loop_counter - number of the email in the current session. options - EpopDownloader.Options"},{"ref":"Pop3mail.EpopDownloader.html#retrieve_and_store_all/2","title":"Pop3mail.EpopDownloader.retrieve_and_store_all/2","type":"function","doc":"Read all emails and save them to disk. epop_client - client returned by :epop_client.connect function. options - EpopDownloader.Options"},{"ref":"Pop3mail.EpopDownloader.html#t:epop_client/0","title":"Pop3mail.EpopDownloader.epop_client/0","type":"type","doc":"Epop client from erlpop"},{"ref":"Pop3mail.EpopDownloader.Options.html","title":"Pop3mail.EpopDownloader.Options","type":"module","doc":"A struct that holds pop3mail parameter options. It&#39;s fields are: delete - delete email after downloading. Default: false. delivered - true/false/nil. Skip emails with/without/whatever Delivered-To header. max_mails - maximum number of emails to download. nil = unlimited output_dir - output directory. password - email account password. port - pop3 server port. save_raw - also save the unprocessed mail in a file called &#39;raw.eml&#39;. server - pop3 server address. ssl - true/false. Turn on/off Secure Socket Layer. username - email account name."},{"ref":"Pop3mail.EpopDownloader.Options.html#t:t/0","title":"Pop3mail.EpopDownloader.Options.t/0","type":"type","doc":""},{"ref":"Pop3mail.FileStore.html","title":"Pop3mail.FileStore","type":"module","doc":"Store header, messages and attachments on the filesystem."},{"ref":"Pop3mail.FileStore.html#dos2unix/1","title":"Pop3mail.FileStore.dos2unix/1","type":"function","doc":"Convert a part&#39;s content text from dos-format (with carriage return + linefeed after each line) to unix-format (with just the linefeed). multipart_part - a Pop3mail.Part"},{"ref":"Pop3mail.FileStore.html#get_default_filename/3","title":"Pop3mail.FileStore.get_default_filename/3","type":"function","doc":"Construct a filename for an email message. filename will be: &#39;message&#39; . . The default file extenstion for text/plain is .txt In other cases the last part of the media_type wil be used as extension."},{"ref":"Pop3mail.FileStore.html#get_line_separator/0","title":"Pop3mail.FileStore.get_line_separator/0","type":"function","doc":"get line seperator for text files. On windows/dos this is carriage return + linefeed, on other platforms it is just the linefeed."},{"ref":"Pop3mail.FileStore.html#mkdir/3","title":"Pop3mail.FileStore.mkdir/3","type":"function","doc":"make directory. Returns created directory name full path. directory is base_dir / name - unsafe_addition unsafe_addition - append this to the directory name. It will be truncated at 45 characters. Unusual characters for the filesystem will be filtered out. If creating the directory with unsafe_addition fails, the directory will be created without it."},{"ref":"Pop3mail.FileStore.html#remove_unwanted_chars/2","title":"Pop3mail.FileStore.remove_unwanted_chars/2","type":"function","doc":"Remove characters which are undesirable for filesystems (like \\ / : * ? &quot; &lt; &gt; | [ ] and control characters)"},{"ref":"Pop3mail.FileStore.html#set_default_filename/1","title":"Pop3mail.FileStore.set_default_filename/1","type":"function","doc":"set default filename in the multipart_part. Calls FileStore.get_default_filename to get the default filename. multipart_part - a Pop3mail.Part"},{"ref":"Pop3mail.FileStore.html#store_mail_header/4","title":"Pop3mail.FileStore.store_mail_header/4","type":"function","doc":"Store mail header. filename is filename_prefix . unsafe_addition . txt unsafe_addition - append this to the filename. It will be truncated at 35 characters. Unusual characters for the filesystem will be filtered out. If storing with unsafe_addition fails, the file will be stored without it."},{"ref":"Pop3mail.FileStore.html#store_part/2","title":"Pop3mail.FileStore.store_part/2","type":"function","doc":"store one part of the body. Text files (media types text/plain, text/html for example) will be converted from dos to unix format on non-windows platforms. multipart_part - a Pop3mail.Part"},{"ref":"Pop3mail.FileStore.html#store_raw/3","title":"Pop3mail.FileStore.store_raw/3","type":"function","doc":"store raw email"},{"ref":"Pop3mail.Handler.html","title":"Pop3mail.Handler","type":"module","doc":"Glue code for received mail to call the parse, decode and store functions"},{"ref":"Pop3mail.Handler.html#check_process_and_store/2","title":"Pop3mail.Handler.check_process_and_store/2","type":"function","doc":"Check if the mail must be skipped, if not process and store the email. It checks if the email has or hasn&#39;t got the Delivered-To header. Mail could be moved from the sent box to the inbox. mail - Handler.Mail options - Handler.Options"},{"ref":"Pop3mail.Handler.html#convert_date_to_dirname/1","title":"Pop3mail.Handler.convert_date_to_dirname/1","type":"function","doc":"Convert date to a directory name meant for storing the email. Returned date is in format yyyymmdd_hhmmss date_str - string with the date. Must be conform RFC 2822 date format."},{"ref":"Pop3mail.Handler.html#decode_body_content/2","title":"Pop3mail.Handler.decode_body_content/2","type":"function","doc":"Decode body: multipart content, base64 and quoted-printable. Returns a list of Pop3mail.Part&#39;s. header_list - list with tuples of {:header, header name, header value}."},{"ref":"Pop3mail.Handler.html#get_sender_name/1","title":"Pop3mail.Handler.get_sender_name/1","type":"function","doc":"Extract the sender name from the email &#39;From&#39; header."},{"ref":"Pop3mail.Handler.html#process_and_store/2","title":"Pop3mail.Handler.process_and_store/2","type":"function","doc":"Create directory for the email based on date and subject, save raw email, store header summary and store everything from the body. mail - Handler.Mail options - Handler.Options"},{"ref":"Pop3mail.Handler.html#process_and_store_body/3","title":"Pop3mail.Handler.process_and_store_body/3","type":"function","doc":"Decode and store body. header_list - list with tuples of {:header, header name, header value}."},{"ref":"Pop3mail.Handler.html#remove_encodings/1","title":"Pop3mail.Handler.remove_encodings/1","type":"function","doc":"This function makes sure that the encoding markers are removed and the text decoded. However, it does not convert to a standard encoding like utf-8 and it also doesn&#39;t mention the encoding types used. What you get is a binary which you might be able to read depending on the character encoding set in your terminal/device/program."},{"ref":"Pop3mail.Handler.Mail.html","title":"Pop3mail.Handler.Mail","type":"module","doc":"A struct that holds mail content. It&#39;s fields are: mail_content - string with the complete raw email content mail_loop_counter - Current number of the email in the retrieval loop. In an POP3 connection each email is numbered, starting at 1. header_list - list with tuples of {:header, header name, header value}. body_content - email body."},{"ref":"Pop3mail.Handler.Mail.html#t:t/0","title":"Pop3mail.Handler.Mail.t/0","type":"type","doc":""},{"ref":"Pop3mail.Handler.Options.html","title":"Pop3mail.Handler.Options","type":"module","doc":"A struct that holds options for the Pop3mail.Handler. It&#39;s fields are: delivered - true/false/nil. Presence, absence or don&#39;t care of the &#39;Delivered-To&#39; email header. save_raw - true/false. Save or don&#39;t save the raw email message. base_dir - directory where the emails must be stored."},{"ref":"Pop3mail.Handler.Options.html#t:t/0","title":"Pop3mail.Handler.Options.t/0","type":"type","doc":""},{"ref":"Pop3mail.Header.html","title":"Pop3mail.Header","type":"module","doc":"Email header related functions."},{"ref":"Pop3mail.Header.html#lookup/3","title":"Pop3mail.Header.lookup/3","type":"function","doc":"Lookup value by header name. Returns a string. If the searched header name occurs multiple times in the list, the result will be the concatenated comma separated value. header_list - list with tuples {:header, header name, value} take - Optional parameter to specify maximum number of headers. Negative number takes last header values."},{"ref":"Pop3mail.Header.html#store/4","title":"Pop3mail.Header.store/4","type":"function","doc":"Store email headers Date,From,To,Cc and Subject in a text file. filename is filename_prefix . unsafe_addition . txt header_list - list with tuples {:header, header name, value} unsafe_addition - append this to the filename if the filesystem allows it."},{"ref":"Pop3mail.Multipart.html","title":"Pop3mail.Multipart","type":"module","doc":"Parser for: RFC 2045 Multipart content type (previously RFC 1341). It works recursive because a multipart content can contain other multiparts. The returned sequential list of Pop3mail.Path structs is flattened. The Part.path field shows where it is in the hierarchy. This module can also be useful to parse RFC 7578 multipart/form-data (previously RFC 2388)."},{"ref":"Pop3mail.Multipart.html#decode/2","title":"Pop3mail.Multipart.decode/2","type":"function","doc":"Return decoded text as binary. encoding - For example: base64, quoted-printable, 7bit, 8bit, etc."},{"ref":"Pop3mail.Multipart.html#decode_base64!/1","title":"Pop3mail.Multipart.decode_base64!/1","type":"function","doc":"Return decoded text as binary. text - base64 encoded text."},{"ref":"Pop3mail.Multipart.html#decode_lines/2","title":"Pop3mail.Multipart.decode_lines/2","type":"function","doc":"Return decoded lines as binary. encoding - For example: base64, quoted-printable, 7bit, 8bit, etc."},{"ref":"Pop3mail.Multipart.html#extract_and_set_filename/3","title":"Pop3mail.Multipart.extract_and_set_filename/3","type":"function","doc":"Extract (file-)name from Content-Disposition value or Content-Type value. Returns Pop3mail.Part with filled-in filename and filename_charset. Example of Content-Disposition header line: Content-Disposition: attachment; filename=abc.pdf RFC 2231 example: filename*0*=us-ascii&#39;en&#39;This%20is%20even%20more%20 filename*1*=%2A%2A%2Afun%2A%2A%2A%20 filename*2=&quot;isn&#39;t it!&quot;"},{"ref":"Pop3mail.Multipart.html#get_param_number/1","title":"Pop3mail.Multipart.get_param_number/1","type":"function","doc":"Get parameter number of key_value. key_value - format must be: key=value or key=value or key*=value. Returns string. Can be empty."},{"ref":"Pop3mail.Multipart.html#get_value/1","title":"Pop3mail.Multipart.get_value/1","type":"function","doc":"Get value of key_value. key_value - format must be: key=value or key=value or key*=value."},{"ref":"Pop3mail.Multipart.html#is_multipart?/1","title":"Pop3mail.Multipart.is_multipart?/1","type":"function","doc":"Is this part a multipart? Looks if the media_type starts with multipart/. It could be multipart/alternative, multipart/relative or multipart/mixed. multipart_part - Pop3mail.Part"},{"ref":"Pop3mail.Multipart.html#lines_continued/2","title":"Pop3mail.Multipart.lines_continued/2","type":"function","doc":"A multipart header line can continue on the next line. When next line starts with a tab-character or when there is a opening double quote not closed yet."},{"ref":"Pop3mail.Multipart.html#parse_content/1","title":"Pop3mail.Multipart.parse_content/1","type":"function","doc":"Parse multipart content. Returns a flattened list of Pop3mail.Part&#39;s This is recursively called for each multipart part, e.g. parse_content calls itself multipart_part - Pop3mail.Part input."},{"ref":"Pop3mail.Multipart.html#parse_content_type/2","title":"Pop3mail.Multipart.parse_content_type/2","type":"function","doc":"Parse multipart Content-Type header line. It can contain media_type, charset, (file-)name and boundary. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input"},{"ref":"Pop3mail.Multipart.html#parse_content_type_parameters/2","title":"Pop3mail.Multipart.parse_content_type_parameters/2","type":"function","doc":"Parse value of content-type header line. It can contain media_type, charset, (file-)name and boundary. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input content_type_parameters - list of parameters in the format key=value"},{"ref":"Pop3mail.Multipart.html#parse_disposition/2","title":"Pop3mail.Multipart.parse_disposition/2","type":"function","doc":"Parse multipart Content-Disposition header line. This is either inline or attachment, and it can contain a filename. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input"},{"ref":"Pop3mail.Multipart.html#parse_disposition_parameters/2","title":"Pop3mail.Multipart.parse_disposition_parameters/2","type":"function","doc":"Parse value of Content-Disposition header line. This is either inline or attachment, and it can contain a filename. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input disposition_parameters - list of parameters in the format key=value"},{"ref":"Pop3mail.Multipart.html#parse_multipart/3","title":"Pop3mail.Multipart.parse_multipart/3","type":"function","doc":"Parse the boundary in the multipart content. raw_content - multipart content boundary_name - multipart boundary to search for path - path in the multipart hierarchy. For example: relative/alternative"},{"ref":"Pop3mail.Multipart.html#parse_part/3","title":"Pop3mail.Multipart.parse_part/3","type":"function","doc":"Parse a part of the multipart content. {part, index} - Numbered part content. Index starts at 1 for part 1 in a multipart. boundary_name - multipart boundary name path - path in the multipart hierarchy. For example: relative/alternative"},{"ref":"Pop3mail.Multipart.html#parse_part_content_id/3","title":"Pop3mail.Multipart.parse_part_content_id/3","type":"function","doc":"Parse multipart Content-ID header line. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input encoding - For example: base64, quoted-printable, 7bit, 8bit, etc. list - lines"},{"ref":"Pop3mail.Multipart.html#parse_part_content_location/3","title":"Pop3mail.Multipart.parse_part_content_location/3","type":"function","doc":"Parse multipart Content-Location header line as defined in RFC 2557. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input encoding - For example: base64, quoted-printable, 7bit, 8bit, etc. list - lines"},{"ref":"Pop3mail.Multipart.html#parse_part_content_type/3","title":"Pop3mail.Multipart.parse_part_content_type/3","type":"function","doc":"Parse multipart Content-Type header line. It can contain media_type, charset, (file-)name and boundary. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input encoding - For example: base64, quoted-printable, 7bit, 8bit, etc. list - lines"},{"ref":"Pop3mail.Multipart.html#parse_part_decode/3","title":"Pop3mail.Multipart.parse_part_decode/3","type":"function","doc":"Decode lines and add them as content in the multipart part. Returns a Pop3mail.Part Is called after all multipart header lines are parsed. multipart_part - Pop3mail.Part input encoding - For example: base64, quoted-printable, 7bit, 8bit, etc. lines - part content splitted in lines"},{"ref":"Pop3mail.Multipart.html#parse_part_disposition/3","title":"Pop3mail.Multipart.parse_part_disposition/3","type":"function","doc":"Parse multipart Content-Disposition header line. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input encoding - For example: base64, quoted-printable, 7bit, 8bit, etc. list - lines"},{"ref":"Pop3mail.Multipart.html#parse_part_finish/3","title":"Pop3mail.Multipart.parse_part_finish/3","type":"function","doc":"Finish parsing multipart header lines and start decode of the part content. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input encoding - For example: base64, quoted-printable, 7bit, 8bit, etc. list - lines"},{"ref":"Pop3mail.Multipart.html#parse_part_lines/3","title":"Pop3mail.Multipart.parse_part_lines/3","type":"function","doc":"Parse multipart header lines. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input encoding - For example: base64, quoted-printable, 7bit, 8bit, etc. list - lines"},{"ref":"Pop3mail.Multipart.html#parse_part_skip/3","title":"Pop3mail.Multipart.parse_part_skip/3","type":"function","doc":"Ignore a multipart header line. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input encoding - For example: base64, quoted-printable, 7bit, 8bit, etc. list - lines"},{"ref":"Pop3mail.Multipart.html#parse_part_transfer_encoding/3","title":"Pop3mail.Multipart.parse_part_transfer_encoding/3","type":"function","doc":"Parse multipart Content-Transfer-Encoding header line. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input encoding - For example: base64, quoted-printable, 7bit, 8bit, etc. list - lines"},{"ref":"Pop3mail.Multipart.html#parse_part_unknown_header/3","title":"Pop3mail.Multipart.parse_part_unknown_header/3","type":"function","doc":"Skip an unknown multipart header line. Logs a warning. Returns a Pop3mail.Part multipart_part - Pop3mail.Part input encoding - For example: base64, quoted-printable, 7bit, 8bit, etc. list - lines"},{"ref":"Pop3mail.Part.html","title":"Pop3mail.Part","type":"module","doc":"A struct that holds a single part of a multipart, and if there isn&#39;t a multipart it contains the email body. It&#39;s fields are: content - binary with the part&#39;s content. charset - character encoding of the content (only applicable for text) media_type - Mime type. Examples: text/plain, text/html, text/rtf, image/jpeg, application/octet-stream filename - binary with filename of the attachment filename_charset - character encoding of the filename inline - true/false/nil. true=inline content, false=attachment, nil=not specified. path - Path within the hierarchy of multipart&#39;s. For example: relative/alternative index - Index number of a part within a multipart. boundary - boundary name of the multipart content_id - cid. Generally HTML refers to embedded objects (images mostly) by cid. That is why the related images have a cid. content_location - URI location as defined in RFC 2557."},{"ref":"Pop3mail.Part.html#t:t/0","title":"Pop3mail.Part.t/0","type":"type","doc":""},{"ref":"Pop3mail.QuotedPrintable.html","title":"Pop3mail.QuotedPrintable","type":"module","doc":"Decode quoted-printable text as in RFC 2045 # 6.7"},{"ref":"Pop3mail.QuotedPrintable.html#decode/1","title":"Pop3mail.QuotedPrintable.decode/1","type":"function","doc":"Decode arg1 string. Returns the result as a character list."},{"ref":"Pop3mail.StringUtils.html","title":"Pop3mail.StringUtils","type":"module","doc":"String manipulation utilities."},{"ref":"Pop3mail.StringUtils.html#contains?/2","title":"Pop3mail.StringUtils.contains?/2","type":"function","doc":"true if search is found in content"},{"ref":"Pop3mail.StringUtils.html#is_empty?/1","title":"Pop3mail.StringUtils.is_empty?/1","type":"function","doc":"test if string is nil or has empty length"},{"ref":"Pop3mail.StringUtils.html#printable/2","title":"Pop3mail.StringUtils.printable/2","type":"function","doc":"Print text if it valid utf-8 encoded. If not, print the alternative text."},{"ref":"Pop3mail.StringUtils.html#remove_balanced/2","title":"Pop3mail.StringUtils.remove_balanced/2","type":"function","doc":"Strip a character. Only when it occurs both at the start and end if the text. Strip once only."},{"ref":"Pop3mail.StringUtils.html#unquoted/1","title":"Pop3mail.StringUtils.unquoted/1","type":"function","doc":"Strip double quotes. Only when they occur at the start and end if the text. Strip balanced. Once only."},{"ref":"Pop3mail.WordDecoder.html","title":"Pop3mail.WordDecoder","type":"module","doc":"Decode words as defined in RFC 2047."},{"ref":"Pop3mail.WordDecoder.html#decode_text/1","title":"Pop3mail.WordDecoder.decode_text/1","type":"function","doc":"Decode a text with possibly encoded-words. Returns a list with tuples {charset, text}. Not encoded text is returned with us-ascii charset."},{"ref":"Pop3mail.WordDecoder.html#decode_word/1","title":"Pop3mail.WordDecoder.decode_word/1","type":"function","doc":"Decode a word. text with possibly encoded-words. Returns a list with tuples {charset, text}. Not encoded text is returned with us-ascii charset."},{"ref":"Pop3mail.WordDecoder.html#decode_word/2","title":"Pop3mail.WordDecoder.decode_word/2","type":"function","doc":"Decode a word with the given encoding. encoding - B/Q B=base64 encoded, Q=Quoted-printable"},{"ref":"Pop3mail.WordDecoder.html#decoded_text_list_to_string/2","title":"Pop3mail.WordDecoder.decoded_text_list_to_string/2","type":"function","doc":"Concat the text from the decoded list. Does NOT convert to a common character set like utf-8. decoded_text_list - list with tuples {charset, text}. add_charset_name - put the name of the charset after the decoded text parts (when it isn&#39;t us-ascii). A hint for the reader if a text contains multiple charsets."},{"ref":"Pop3mail.WordDecoder.html#get_charsets_besides_ascii/1","title":"Pop3mail.WordDecoder.get_charsets_besides_ascii/1","type":"function","doc":"returns sorted unique list of charsets. Because the non-encoded text has the us-ascii charset (a subset of utf-8 iso-8859-1 cp1251) we are particulary interested in the other charsets. decoded_text_list - list with tuples {charset, text}."}]